mui.plusReady(function() {

	(function($) {
		var update = {

			//正式版本更新接口
			GetUpdateURL: function() {
				return 'http://app.765mall.com/update';
			},

			//热更新接口
			GetHotUpdateURL: function() {
				return 'http://app.765mall.com/index.php/update/diffUpdate';
			},

			//删除安装包
			removeWgt: function(path) {
				plus.io.resolveLocalFileSystemURL(path, function(entry) {
					entry.remove(function(e) {
						console.log("删除成功");
					}, function(e) {
						console.log("删除失败");
					});
				});
			},

			//安装更新包
			installWgt: function(wgtpath, isforce) {
				plus.runtime.install(wgtpath, {
					force: isforce //是否强制安装
				}, function(wgtinfo) {

					plus.nativeUI.closeWaiting();
					$.alert('更新成功!');
					//删除安装包
					update.removeWgt(wgtpath);
					//更新完成，须重启应用
					plus.runtime.restart();
				}, function(error) {
					plus.nativeUI.closeWaiting();
					$.alert('应用更新失败!');
					//删除安装包
					update.removeWgt(wgtpath);
				});
			},

			//下载更新包
			downloadWgt: function(downloadObj) {
				var wgtWaiting = plus.nativeUI.showWaiting("开始更新");
				var oldPercent = 1;
				var downloadTask = plus.downloader.createDownload(
					downloadObj.url, {
						filename: "_doc/update/"
					},
					downloadObj.callback
				);
				//监控下载进度
				downloadTask.addEventListener("statechanged", function(download, status) {
					switch (download.state) {
						case 3:
							var percent = parseInt(download.downloadedSize / download.totalSize * 100);
							//只有在进度大于5%的时候才更新
							if (percent - oldPercent >= 5) {
								oldPercent = percent;
								wgtWaiting.setTitle("已下载 " + percent + "%");
							}
							break;
						case 4:
							wgtWaiting.setTitle("下载完成");
							break;
					}
				});
				downloadTask.start();
			},

			//热更新
			hotUpdate: function() {
				//获取热更版本
				plus.runtime.getProperty(plus.runtime.appid, function(info) {
					var version = info.version;

					$.ajax({
						type: 'post',
						dataType: "json",
						timeout: 6000,
						contentType: "application/x-www-form-urlencoded; charset=utf-8",
						url: update.GetHotUpdateURL(),
						data: {
							version: version
						},
						success: function(res) {
							if (res.status === 200) {
								var btnArr = [];
								if (res.data.is_force) {
									btnArr = ['立刻安装'];
								} else {
									btnArr = ['立刻安装', '稍后安装'];
								}
								plus.nativeUI.confirm(
									res.data.note,
									function(event) {
										if (btnArr[event.index] == '立刻安装') {
											update.downloadWgt({
												url: res.data.url,
												callback: function(download, status) {
													if (status == 200) {
														update.installWgt(download.filename, true);
													} else {
														plus.nativeUI.closeWaiting();
														$.alert("下载失败,请稍后再试！");
													}
												}
											});
										}
									},
									res.data.title,
									btnArr);
							}
						},
						error: function(jqXHR, textStatus, errorThrown) {
							app.toast('网络连接失败，请重新尝试一下');
						}
					});
				});
			},

			//ios正式版本更新
			iosUpdate: function(oVersion) {
				//正式版本不需要更新则处理热更版本
				if (oVersion.version > plus.runtime.version) {
					plus.nativeUI.confirm(oVersion.note, function(event) {
						//打开appstore地址
						plus.runtime.openURL(oVersion.url);
					}, oVersion.title, ["立刻安装"]);

				} else {
					update.hotUpdate();
				}
			},

			//安卓正式版本更新
			androidUpdate: function(oVersion) {
				//正式版本不需要更新则处理热更版本
				if (oVersion.version > plus.runtime.version) {
					plus.nativeUI.confirm(oVersion.note, function(event) {
						update.downloadWgt({
							url: oVersion.url,
							callback: function(download, status) {
								if (status == 200) {
									update.installWgt(download.filename, false);
								} else {
									plus.nativeUI.closeWaiting();
									$.alert("下载失败,请稍后再试！");
								}
							}
						});
					}, oVersion.title, ["立刻安装"]);

				} else {
					update.hotUpdate();
				}

			}
		};

		//获取更新版本
		$.getJSON(update.GetUpdateURL(), {}, function(data) {
			if (plus.os.name == 'iOS') {
				update.iosUpdate(data.iOS);
			} else {
				update.androidUpdate(data.Android)
			}
		});
	})(mui);
});